diff a/PEA/MergeAllVirts.java b/PEA/MergeAllVirts.java
--- /dev/null
+++ b/PEA/MergeAllVirts.java
@@ -0,0 +1,230 @@
+import java.io.*;
+
+class MergeAllVirts {
+    int a;
+    int b;
+    int c = 100;
+
+    public MergeAllVirts() {}
+    public MergeAllVirts(boolean cond) {
+        if (cond) {
+            this.a = 1;
+            this.b = 20;
+            this.c = 300;
+            blackhole(); // kill locals, so LV0 = this is dead here.
+        } else {
+            this.a = 100;
+            this.b = 50;
+            this.c = 7;
+            blackhole(); // kill locals.
+        }
+        // merge 2 predecessors, but LV0 is not live here.
+        // we need to merge allocation states, or wrong current allocation state is wrong.
+    }
+
+    public int sum() {
+        return a + b + c;
+    }
+
+    public static int add(boolean cond) {
+        MergeAllVirts obj = new MergeAllVirts();
+        if (cond) {
+            obj.a = 1;
+        } else {
+            obj.b = 2;
+        }
+        //obj3 = phi(obj1, obj2);
+        return obj.sum();
+    }
+
+    public static MergeAllVirts cached;
+    public static void escaped(boolean cond) {
+        MergeAllVirts obj = new MergeAllVirts();
+
+        if (cond) {
+            obj.a = 1;
+        } else {
+            obj.b = 2;
+        }
+        // return obj;  we don't materialize at exit. if it's virtual, keep it virtual.
+        cached = obj; // materialize here.
+    }
+
+    static void check_result(boolean cond, int sum) {
+        if ((cond && sum != 101) || (!cond && sum != 102)) {
+            throw new RuntimeException("wrong answer: " + sum);
+        }
+    }
+    static void blackhole() {} // not inline this.
+    static void blackhole(MergeAllVirts obj) {} // not inline this.
+    static void blackhole(File file) throws IOException {}
+    public static MergeAllVirts escaped2(boolean cond1, boolean cond2) {
+        MergeAllVirts obj = new MergeAllVirts();
+
+        if (cond1) {
+            obj.a = 20;
+        } else {
+            obj.b = 30;
+        }
+        if (cond2) {
+            blackhole(obj); // materialize obj here.
+        }
+        return obj;
+    }
+
+    static void check_result2(boolean cond1, int sum) {
+        boolean okay = true;
+
+        if (cond1) {
+            okay = sum == 120;
+        } else {
+            okay = sum == 130;
+        }
+
+        if (!okay) {
+            throw new RuntimeException("wrong answer: " + cond1 + " " + sum);
+        }
+    }
+
+    public static MergeAllVirts escaped3(boolean cond1, boolean cond2) {
+        MergeAllVirts obj = new MergeAllVirts();
+
+        if (cond1) {
+            obj.a = 20;
+        } else {
+            obj.b = 30;
+        }
+        if (cond2) {
+            blackhole(obj); // materialize obj here.
+            obj.a = 300;
+        }
+        return obj;
+    }
+
+    static void check_result3(boolean cond1, boolean cond2, int sum) {
+        boolean okay = true;
+
+        if (cond1) {
+            if (cond2)
+                okay = sum == 400; // 300 + 0 + 100
+            else
+                okay = sum == 120;
+        } else {
+            if (cond2)
+                okay = sum == 430; // 300 + 30 + 100
+            else
+                okay = sum == 130;
+        }
+
+        if (!okay) {
+            throw new RuntimeException("wrong answer: " + cond1 + " "  + cond2 + " " + sum);
+        }
+    }
+    public static void escaped4(boolean cond) {
+        MergeAllVirts obj = new MergeAllVirts(cond);
+
+        // return obj;  we don't materialize at exit. if it's virtual, keep it virtual.
+        cached = obj; // materialize here.
+    }
+
+    static void check_result4(boolean cond, int sum) {
+        boolean okay;
+
+        if (cond) {
+            okay = sum == 321;
+        } else {
+            okay = sum == 157;
+        }
+
+        if (!okay) {
+            throw new RuntimeException("wrong answer: " + cond + " "  + sum);
+        }
+    }
+
+    private static void fail(String msg, Object... args) {
+        throw new RuntimeException(msg);
+    }
+
+    // JVM-1880: merge the same object but they have different aliases in its predecessors.
+    // one common reason is exception handler. C2 parse forces to generate a phi for them.
+    // inspired by sun.net.sdp.SdpProvider::<init>
+    public static Object merge_2virts(File file) {
+        MergeAllVirts obj = new MergeAllVirts();
+
+        try {
+            blackhole(file);
+        } catch(IOException e) {
+            // create a phi node : n = phi(region, _, obj)
+            fail("Error reading %s: %s", file, e.getMessage());
+        }
+        // merge here: phi(r, m, n) and n is phi(region, _, obj)
+        // same object but different aliases!
+        return obj;
+    }
+
+    public static MergeAllVirts merge_virts(boolean cond1, boolean cond2) {
+        MergeAllVirts obj = new MergeAllVirts();
+        if (cond1) {
+            if (cond2) {
+                obj.a = 1;
+            } else {
+                obj.a = 2;
+            }
+            blackhole(); // merge obj.a here.
+        } else {
+            obj.b = 20;  // merge both obj.a and obj.b
+        }
+        return obj;
+    }
+
+    static void check_result_virts(boolean cond1, boolean cond2, int sum) {
+        boolean okay;
+        if (cond1) {
+            if (cond2) {
+                okay = sum == 101;
+            } else {
+                okay = sum == 102;
+            }
+        } else {
+            okay = sum == 120;
+        }
+
+        if (!okay) {
+            throw new RuntimeException("wrong answer: " + cond1 + " " + cond2 + " "  + sum);
+        }
+    }
+
+    public static void main(String[] args) {
+        long iterations = 0;
+        File file = new File("hello");
+        boolean cond2 = true;
+        try {
+            while (true) {
+                boolean cond = 0 == (iterations & 0xf);
+                int sum = MergeAllVirts.add(cond);
+                check_result(cond, sum);
+
+                MergeAllVirts.escaped(cond);
+                check_result(cond, cached.sum());
+
+                cond2 = cond2 ^ cond;
+                sum = MergeAllVirts.escaped2(cond, cond2).sum();
+                check_result2(cond, sum);
+
+                sum = MergeAllVirts.escaped3(cond, cond2).sum();
+                check_result3(cond, cond2, sum);
+
+                MergeAllVirts.escaped4(cond);
+                check_result4(cond, cached.sum());
+
+                MergeAllVirts.merge_2virts(file);
+
+                sum = MergeAllVirts.merge_virts(cond, cond2).sum();
+                check_result_virts(cond, cond2, sum);
+                iterations++;
+            }
+        } finally {
+            System.err.println("Epsilon Test: " + iterations);
+        }
+    }
+}
diff a/PEA/MergeEscaped.java b/PEA/MergeEscaped.java
--- /dev/null
+++ b/PEA/MergeEscaped.java
@@ -0,0 +1,158 @@
+class MergeEscaped {
+    int a;
+    int b;
+    int c = 100;
+
+    public MergeEscaped() {}
+    public MergeEscaped(boolean cond) {
+        if (cond) {
+            this.a = 1;
+            this.b = 20;
+            this.c = 300;
+            blackhole(); // kill locals, so LV0 = this is dead here.
+        } else {
+            this.a = 100;
+            this.b = 50;
+            this.c = 7;
+            blackhole(); // kill locals.
+        }
+        // merge 2 predecessors, but LV0 is not live here.
+        // we need to merge allocation states, or wrong current allocation state is wrong.
+    }
+
+    public int sum() {
+        return a + b + c;
+    }
+
+    public static MergeEscaped cached;
+
+    void blackhole() {} // not inline this.
+    static void blackhole(Object obj) {} // not inline this.
+
+    public static MergeEscaped escaped(boolean cond1) {
+        MergeEscaped obj = new MergeEscaped();
+
+        if (cond1) {
+            blackhole(obj);
+            obj.a = 20;
+        } else {
+            obj.b = 30;
+            blackhole(obj);
+        }
+        obj.c = 100;
+        return obj;
+    }
+
+    static void check_result(boolean cond1, int sum) {
+        boolean okay = true;
+
+        if (cond1) {
+            okay = sum == 120;
+        } else {
+            okay = sum == 130;
+        }
+
+        if (!okay) {
+            throw new RuntimeException("wrong answer: " + cond1 + " " + sum);
+        }
+    }
+    public static MergeEscaped escaped2(boolean cond1) {
+        MergeEscaped obj = new MergeEscaped();
+
+        for (int i = 0; i < 100; ++i) {
+            if (cond1) {
+                blackhole(obj);
+                obj.a = 20;
+            } else {
+                obj.b = 30;
+            }
+        }
+        return obj;
+    }
+
+    public static MergeEscaped escaped3(boolean cond1, boolean cond2) {
+        MergeEscaped obj = new MergeEscaped();
+        if (cond1) {
+            obj.a = 10; // V
+        } else {
+            if (cond2) {
+                blackhole(obj); // E1
+                obj.a = 20;
+            } else {
+                blackhole(obj); // E2
+                obj.b = 30;
+            }
+            obj.c = 300;        // PHI(E1, E2),
+        }                       // PHI'(V, PHI)
+        return obj;
+    }
+
+    static void check_result3(boolean cond1, boolean cond2, int sum) {
+        boolean okay = true;
+
+        if (cond1) {
+            okay = sum == 110;
+        } else {
+            if (cond2) {
+                okay = sum == 320;
+            } else {
+                okay = sum == 330;
+            }
+        }
+
+        if (!okay) {
+            throw new RuntimeException("wrong answer: " + cond1 + " " +  cond2 + " " + sum);
+        }
+    }
+
+    private static void test4(MergeEscaped obj, int cond) {
+        if (cond == 0) {
+            obj.a = 1;
+        } else if (cond == 1) {
+            obj.a = 2;
+        } else {
+            blackhole(obj);
+        }
+    }
+
+    public static MergeEscaped escaped4(boolean cond1, boolean cond2) {
+        MergeEscaped obj = new MergeEscaped();
+
+        int cond = 0;
+        if (cond1) {
+            cond = 2;  // cond1 << 1
+        }
+        if (cond2) {
+            cond = cond + 1;
+        }
+
+        test4(obj,  cond);
+        blackhole(obj);
+        return obj;
+    }
+
+    public static void main(String[] args) {
+        long iterations = 0;
+
+        try {
+            while (true) {
+                boolean cond = 0 == (iterations & 0xf);
+                boolean cond2 = 7 == (iterations& 0xf);
+
+                int sum = MergeEscaped.escaped(cond).sum();
+                check_result(cond, sum);
+
+                sum = MergeEscaped.escaped2(cond).sum();
+                check_result(cond, sum);
+
+                sum = MergeEscaped.escaped3(cond, cond2).sum();
+                check_result3(cond, cond2, sum);
+
+                escaped4(cond, cond2);
+                iterations++;
+            }
+        } finally {
+            System.err.println("Epsilon Test: " + iterations);
+        }
+    }
+}
diff a/PEA/MergeIfElseParanoid.java b/PEA/MergeIfElseParanoid.java
--- /dev/null
+++ b/PEA/MergeIfElseParanoid.java
@@ -0,0 +1,29 @@
+class MergeIfElseParanoid {
+    static class Node {
+       public Node _next;
+       public Node() {}
+    }
+
+    static Object _global;
+    static Object _global2;
+
+    public static void test(boolean cond) {
+        Object foo = new Object();
+        if (cond) {
+            _global = foo;
+        }
+        // When `cond == true`, we materialize foo a second time. We cannot
+        // eliminate the original allocation because we need for when
+        // `cond == false`.
+        //
+        // If we have passive materialization, we would materialize foo in the
+        // predecessor, and the original object would be dead.
+        _global2 = foo;
+    }
+
+    public static void main(String[] args ) {
+        for (int i=0; i < 100_000; ++i) {
+            test(0 == (i& 0xf));
+        }
+    }
+}
diff a/PEA/MergeLoop.java b/PEA/MergeLoop.java
--- /dev/null
+++ b/PEA/MergeLoop.java
@@ -0,0 +1,29 @@
+class MergeLoop {
+    static void blackhole(Object obj) {}
+    static void test(int val) {
+        Object obj1 = new Object();
+        Object obj2 = new Object();
+
+        for (int i = 0; i < val; ++i)  {
+            // to prevent phi from being elided, we need to ensure obj is not loop invariant!
+            // the following shuffle just confuses ciTypeFlow
+
+            // swap
+            Object t = obj1;
+            obj1 = obj2;
+            obj2 = t;
+            // swap again
+            t = obj1;
+            obj1 = obj2;
+            obj2 = t;
+
+            blackhole(obj1); // escape here.
+        }
+    }
+
+    public static void main(String[] args) {
+        for (int i = 0; i < 200_000; ++i) {
+            test(24);
+        }
+    }
+}
diff a/PEA/SimpleLoop.java b/PEA/SimpleLoop.java
--- /dev/null
+++ b/PEA/SimpleLoop.java
@@ -0,0 +1,43 @@
+class SimpleLoop {
+    Object[] elements;
+
+    class Iterator {
+        int idx = 0;
+
+        Object next() {
+            return elements[idx++];
+        }
+    }
+
+    Iterator iterator() {
+        return new Iterator();
+    }
+
+    // based on java.util.ImmutableCollections$SetN::toArray
+    Object[] toArray(int size) {
+        Object[] array = new Object[size];
+        Iterator it = iterator();
+        for (int i = 0; i < size; i++) { array[i] = it.next(); }
+        return array;
+    }
+
+    public static void main(String[] args) {
+        SimpleLoop kase = new SimpleLoop();
+
+        int sz = 1024;
+        kase.elements = new Object[sz];
+        for (int i=0; i< sz; ++i ) kase.elements[i] = new Object();
+
+        Object[] results = null;
+        for (int i = 0; i < 1_000_000; ++i) {
+            results = kase.toArray(24);
+        }
+
+        for (int i =0; i< 24; ++i) {
+            if (results[i] != kase.elements[i]) {
+                throw new RuntimeException("wong answser at " + i);
+            }
+        }
+    }
+
+}
diff a/PEA/Str.java b/PEA/Str.java
--- /dev/null
+++ b/PEA/Str.java
@@ -0,0 +1,14 @@
+class Str {
+    public String strBuilderRepro() {
+        return new StringBuilder(10).toString();
+    }
+
+    public static void main(String[] args)  {
+        Str s = new Str();
+        String foo = "";
+        for (int i = 0; i < 20000; ++i) {
+            foo = s.strBuilderRepro();
+        }
+        System.out.println(foo);
+    }
+}
diff a/PEA/UnsafeStoreReference.java b/PEA/UnsafeStoreReference.java
--- /dev/null
+++ b/PEA/UnsafeStoreReference.java
@@ -0,0 +1,31 @@
+import jdk.internal.misc.Unsafe;
+
+class UnsafeStoreReference {
+  private static final Unsafe U = Unsafe.getUnsafe();
+  private transient volatile Node head;
+  private static final long HEAD
+              = U.objectFieldOffset(UnsafeStoreReference.class, "head");
+  private transient volatile Node tail;
+
+  static class Node {}
+
+  // inspired from java.util.concurrent.locks.AbstractQueuedSynchronizer::tryInitializeHead
+  void test() {
+    Node h = new Node();
+
+    if (U.compareAndSetReference(this, HEAD, null, h))
+        tail = h;
+  }
+
+  public static void main(String[] args) {
+    UnsafeStoreReference kase = new UnsafeStoreReference();
+
+    for (int i = 0; i < 100_000; i++) {
+        kase.test();
+        if (kase.head != kase.tail) {
+            throw new RuntimeException("wrong result");
+        }
+        kase.head = kase.tail = null;
+    }
+  }
+}
diff a/PEA/WrongBCIAfterMotion.java b/PEA/WrongBCIAfterMotion.java
--- /dev/null
+++ b/PEA/WrongBCIAfterMotion.java
@@ -0,0 +1,39 @@
+class WrongBCIAfterMotion {
+    static int counter;
+
+    private int id;
+
+    public WrongBCIAfterMotion(int id) {
+        this.id = id;
+    }
+
+    static void blackhole(Object obj) {
+    }
+
+    public static void main(String[] args) {
+        final int n = 300_000;
+
+        for (int i =0; i<n;++i) {
+        /*
+         * PEA moves AllocateNode from 8 to 24. however, there's memory side-effect in between.
+         * PEA is using the JVMState including bci=8.
+         * This is wrong under -XX:-UseTLAB and -XX:OptimizeALot.
+         *
+       8: new           #8                  // class WrongBCIAfterMotion
+      11: dup
+      12: getstatic     #14                 // Field counter:I
+      15: dup
+      16: iconst_1
+      17: iadd
+      18: putstatic     #14                 // Field counter:I
+      21: invokespecial #17                 // Method "<init>":(I)V
+      24: invokestatic  #20                 // Method blackhole:(Ljava/lang/Object;)V
+         */
+            blackhole(new WrongBCIAfterMotion(counter++));
+        }
+
+        if (counter != n) {
+            throw new RuntimeException("Wrong result");
+        }
+    }
+}
diff a/PEA/auto.rb b/PEA/auto.rb
--- /dev/null
+++ b/PEA/auto.rb
@@ -0,0 +1,41 @@
+#!/usr/bin/env ruby
+
+PROBLEM_LIST = ["run_composite.sh", "run_merge_if_else_paranoid.sh", "run_wrong_bci_after_motion.sh"]
+
+if $0 == __FILE__
+  puts  "using #{%x|which java|}"
+  java_version = `java --version`
+
+  jvm_options ="-Xlog:gc -XX:+DoPartialEscapeAnalysis"
+  if java_version =~ /\(.*debug build/
+    jvm_options << " -XX:+PrintEscapeAnalysis -XX:+PrintEliminateAllocations -XX:+PrintOptoStatistics"
+  end
+  puts jvm_options
+
+  failed = []
+  Dir.glob("run*.sh").each do |t|
+    print "[#{t}]"
+
+    ret = system("sh ./#{t} #{jvm_options} > #{t}.log")
+    if ret == nil then
+      puts "\t fail to execute."
+    else
+      # exitcode == 3 is out of memory. acceptable.
+      if ret or $?.exitstatus == 3 then
+        puts "\tpassed."
+      elsif  PROBLEM_LIST.include? t then
+        puts "\tis a known issue."
+      else
+        puts "\tfailed!"
+        failed.push("[#{t}]")
+      end
+    end
+  end
+
+  if failed.length() > 0
+    puts "failed #{failed.length} tests:"
+    failed.each { |test| puts "\t#{test}" }
+    exit(1)
+  end
+  puts "passed all tests!"
+end
diff a/PEA/run1.sh b/PEA/run1.sh
--- /dev/null
+++ b/PEA/run1.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:CompileCommand='compileOnly,Example1.test*' $* Example1
diff a/PEA/run1_ivanov.sh b/PEA/run1_ivanov.sh
--- /dev/null
+++ b/PEA/run1_ivanov.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xcomp -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:CompileOnly='Example1_ivanov.ivanov' -XX:CompileCommand=dontinline,Example1_ivanov.blackhole $* Example1_ivanov
diff a/PEA/run2.sh b/PEA/run2.sh
--- /dev/null
+++ b/PEA/run2.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xcomp -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:-UseTLAB -XX:CompileOnly='Example2.foo' -XX:CompileCommand=dontinline,Example2.blackhole $* Example2
diff a/PEA/run2_1.sh b/PEA/run2_1.sh
--- /dev/null
+++ b/PEA/run2_1.sh
@@ -0,0 +1,3 @@
+#!/usr/bin/bash
+java -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:CompileCommand='compileonly,Example2_1::foo*' -XX:CompileCommand=dontinline,Example2.blackhole $* Example2_1
+java -Xcomp -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:CompileCommand='compileonly,Example2_1::foo*' -XX:CompileCommand=dontinline,Example2.blackhole $* Example2_1
diff a/PEA/run2_merykitty.sh b/PEA/run2_merykitty.sh
--- /dev/null
+++ b/PEA/run2_merykitty.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -ea -Xcomp -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:-UseTLAB -XX:CompileOnly='Example2_merykitty.foo' -XX:CompileCommand=dontinline,Example2_merykitty.blackhole $* Example2_merykitty
diff a/PEA/run2b.sh b/PEA/run2b.sh
--- /dev/null
+++ b/PEA/run2b.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:CompileCommand='compileonly,Example2b::foo*' $* Example2b
diff a/PEA/run3.sh b/PEA/run3.sh
--- /dev/null
+++ b/PEA/run3.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -XX:+PrintCompilation -XX:CompileCommand='CompileOnly,Example3::confined_close' -XX:CompileCommand=quiet -XX:-UseOnStackReplacement -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -Xms32M -Xmx32M -XX:-TieredCompilation  $* Example3
diff a/PEA/run3_1.sh b/PEA/run3_1.sh
--- /dev/null
+++ b/PEA/run3_1.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:CompileOnly='Example3_1.foo' -XX:CompileCommand=dontinline,Example1.blackhole $* Example3_1
diff a/PEA/run3_2.sh b/PEA/run3_2.sh
--- /dev/null
+++ b/PEA/run3_2.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xms8M -Xmx8M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:-TieredCompilation -XX:CompileOnly='Example3_2.foo' $* Example3_2
diff a/PEA/run_EscapeInInitializer.sh b/PEA/run_EscapeInInitializer.sh
--- /dev/null
+++ b/PEA/run_EscapeInInitializer.sh
@@ -0,0 +1,2 @@
+#!/bin/bash
+java -XX:+UnlockExperimentalVMOptions  -XX:-TieredCompilation -XX:CompileCommand='compileonly,EscapeInInitializer::*' -XX:CompileCommand='inline,EscapeInInitializer::the_answer' -XX:-UseTLAB -XX:-UseOnStackReplacement -Xbatch $* EscapeInInitializer
diff a/PEA/run_badgraph_volatile.sh b/PEA/run_badgraph_volatile.sh
--- /dev/null
+++ b/PEA/run_badgraph_volatile.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xms8M -Xmx8M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:-UseTLAB -XX:-TieredCompilation -XX:CompileOnly='BadGraphVolatile.foo' -XX:CompileCommand='dontinline,BadGraphVolatile::blackhole' -Xbatch $* BadGraphVolatile
diff a/PEA/run_composite.sh b/PEA/run_composite.sh
--- /dev/null
+++ b/PEA/run_composite.sh
@@ -0,0 +1,2 @@
+#!/bin/bash
+java -XX:CompileCommand=compileonly,CompositeObjects::main -XX:CompileCommand='dontinline,*::blackhole' -XX:-TieredCompilation -Xbatch -XX:+UnlockExperimentalVMOptions -XX:+PEAParanoid $* CompositeObjects
diff a/PEA/run_crazy_exception.sh b/PEA/run_crazy_exception.sh
--- /dev/null
+++ b/PEA/run_crazy_exception.sh
@@ -0,0 +1,1 @@
+java -Xms16M -Xmx16M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:-TieredCompilation -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:-UseTLAB -XX:CompileCommand=dontinline,CrazyException.blackhole -XX:CompileCommand=compileonly,CrazyException.foo  -XX:CompileCommand=quiet $* CrazyException 
diff a/PEA/run_exception.sh b/PEA/run_exception.sh
--- /dev/null
+++ b/PEA/run_exception.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xms16M -Xmx16M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:-TieredCompilation -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:CompileCommand=dontinline,CrazyException.blackhole -XX:CompileCommand=compileonly,CrazyException.foo -XX:CompileCommand=dontinline,CrazyException.close $* CrazyException
diff a/PEA/run_get_field_is_alias.sh b/PEA/run_get_field_is_alias.sh
--- /dev/null
+++ b/PEA/run_get_field_is_alias.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -XX:+UnlockExperimentalVMOptions -Xbatch -XX:CompileCommand=compileOnly,GetFieldIsAlias::main -XX:CompileCommand=quiet $* GetFieldIsAlias
diff a/PEA/run_load_self_into_field.sh b/PEA/run_load_self_into_field.sh
--- /dev/null
+++ b/PEA/run_load_self_into_field.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -ea -Xcomp -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:CompileCommand='compileOnly,LoadSelfIntoField.test*' $* LoadSelfIntoField
diff a/PEA/run_mat_in_monitor.sh b/PEA/run_mat_in_monitor.sh
--- /dev/null
+++ b/PEA/run_mat_in_monitor.sh
@@ -0,0 +1,4 @@
+#!/usr/bin/bash
+set -x
+java -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:-UseOnStackReplacement -XX:-TieredCompilation -XX:-UseTLAB -XX:CompileCommand='compileOnly,MatInMonitor.test*' $* MatInMonitor
+java -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:-UseOnStackReplacement -XX:-TieredCompilation -XX:-UseTLAB -XX:CompileCommand='compileOnly,MatInMonitor.test*' -XX:-DoEscapeAnalysis $* MatInMonitor
diff a/PEA/run_materialize_member.sh b/PEA/run_materialize_member.sh
--- /dev/null
+++ b/PEA/run_materialize_member.sh
@@ -0,0 +1,2 @@
+#!/bin/bash
+java  -XX:+UnlockExperimentalVMOptions -XX:CompileCommand=dontinline,java.util.Collections::addAll -XX:-UseOnStackReplacement -XX:CompileCommand=compileonly,MaterializeMember::test -Xbatch $* MaterializeMember
diff a/PEA/run_merge_all_virts.sh b/PEA/run_merge_all_virts.sh
--- /dev/null
+++ b/PEA/run_merge_all_virts.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-TieredCompilation -XX:-UseOnStackReplacement -XX:-UseTLAB -XX:CompileCommand=dontinline,MergeAllVirts::blackhole -XX:CompileCommand='compileonly,MergeAllVirts::*' -Xbatch $* MergeAllVirts
diff a/PEA/run_merge_escaped.sh b/PEA/run_merge_escaped.sh
--- /dev/null
+++ b/PEA/run_merge_escaped.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xms32M -Xmx32M -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-TieredCompilation -XX:-UseOnStackReplacement -XX:-UseTLAB -XX:CompileCommand=dontinline,MergeEscaped::blackhole -XX:CompileCommand='compileonly,MergeEscaped::*' $* MergeEscaped
diff a/PEA/run_merge_if_else_paranoid.sh b/PEA/run_merge_if_else_paranoid.sh
--- /dev/null
+++ b/PEA/run_merge_if_else_paranoid.sh
@@ -0,0 +1,2 @@
+#!/bin/bash
+java -XX:CompileCommand=compileonly,MergeIfElseParanoid::test -XX:-TieredCompilation -Xbatch -XX:+UnlockExperimentalVMOptions -XX:+PEAParanoid $* MergeIfElseParanoid
diff a/PEA/run_merge_loops.sh b/PEA/run_merge_loops.sh
--- /dev/null
+++ b/PEA/run_merge_loops.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -XX:+UnlockExperimentalVMOptions  -XX:-TieredCompilation -XX:-UseOnStackReplacement -XX:+UseTLAB -XX:CompileCommand=dontinline,MergeLoop::blackhole -XX:CompileCommand='compileonly,MergeLoop::test' -Xbatch $* MergeLoop
diff a/PEA/run_simple_loop.sh b/PEA/run_simple_loop.sh
--- /dev/null
+++ b/PEA/run_simple_loop.sh
@@ -0,0 +1,1 @@
+java -XX:-TieredCompilation -XX:-UseOnStackReplacement -XX:CompileCommand=compileonly,SimpleLoop::toArray -XX:+UnlockExperimentalVMOptions -XX:CompileCommand='dontinline,SimpleLoop$Iterator::next' $* SimpleLoop
diff a/PEA/run_str.sh b/PEA/run_str.sh
--- /dev/null
+++ b/PEA/run_str.sh
@@ -0,0 +1,2 @@
+#!/usr/bin/bash
+java -Xcomp -Xms16M -Xmx16M -XX:+UnlockExperimentalVMOptions -XX:+AlwaysPreTouch -XX:+UnlockExperimentalVMOptions -XX:+UseEpsilonGC -XX:-UseOnStackReplacement -XX:CompileOnly='Str.strBuilderRepro' -XX:-Inline $* Str
diff a/PEA/run_streams.sh b/PEA/run_streams.sh
--- /dev/null
+++ b/PEA/run_streams.sh
@@ -0,0 +1,1 @@
+java -Xbatch -XX:-TieredCompilation -XX:+UnlockExperimentalVMOptions $* CountUppercase This year I would like to run ALL languages in one VM.
diff a/PEA/run_unsafe_stores.sh b/PEA/run_unsafe_stores.sh
--- /dev/null
+++ b/PEA/run_unsafe_stores.sh
@@ -0,0 +1,1 @@
+java --add-exports java.base/jdk.internal.misc=ALL-UNNAMED -XX:+UnlockExperimentalVMOptions -XX:CompileCommand=compileonly,UnsafeStoreReference::test $*  UnsafeStoreReference
diff a/PEA/run_wrong_bci_after_motion.sh b/PEA/run_wrong_bci_after_motion.sh
--- /dev/null
+++ b/PEA/run_wrong_bci_after_motion.sh
@@ -0,0 +1,2 @@
+#!/bin/bash
+java -XX:+UnlockExperimentalVMOptions -XX:-TieredCompilation -XX:+DeoptimizeALot -XX:CompileCommand=dontinline,WrongBCIAfterMotion::blackhole -XX:-UseTLAB $* WrongBCIAfterMotion
diff a/src/hotspot/share/compiler/methodLiveness.hpp b/src/hotspot/share/compiler/methodLiveness.hpp
--- a/src/hotspot/share/compiler/methodLiveness.hpp
+++ b/src/hotspot/share/compiler/methodLiveness.hpp
@@ -45,10 +45,17 @@
     , _is_valid(false)
   {}
 
   void set_is_valid() { _is_valid = true; }
   bool is_valid() const { return _is_valid; }
+
+#ifdef ASSERT
+  bool at(idx_t index) const {
+    assert(is_valid(), "reading invalid");
+    return ResourceBitMap::at(index);
+  }
+#endif
 };
 
 class MethodLiveness : public ArenaObj {
  public:
   // The BasicBlock class is used to represent a basic block in the
diff a/src/hotspot/share/libadt/vectset.cpp b/src/hotspot/share/libadt/vectset.cpp
--- a/src/hotspot/share/libadt/vectset.cpp
+++ b/src/hotspot/share/libadt/vectset.cpp
@@ -1,7 +1,7 @@
 /*
- * Copyright (c) 1997, 2019, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 1997, 2022, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License version 2 only, as
  * published by the Free Software Foundation.
@@ -38,26 +38,24 @@
 }
 
 void VectorSet::init(Arena* arena) {
   _size = 2;
   _data = NEW_ARENA_ARRAY(arena, uint32_t, 2);
-  _data_size = 2;
   _set_arena = arena;
   _data[0] = 0;
   _data[1] = 0;
 }
 
 // Expand the existing set to a bigger size
 void VectorSet::grow(uint new_word_capacity) {
   assert(new_word_capacity < (1U << 30), "");
   uint x = next_power_of_2(new_word_capacity);
-  if (x > _data_size) {
+  if (x > _size) {
     _data = REALLOC_ARENA_ARRAY(_set_arena, uint32_t, _data, _size, x);
-    _data_size = x;
+    Copy::zero_to_bytes(_data + _size, (x - _size) * sizeof(uint32_t));
+    _size = x;
   }
-  Copy::zero_to_bytes(_data + _size, (x - _size) * sizeof(uint32_t));
-  _size = x;
 }
 
 // Insert a member into an existing Set.
 void VectorSet::insert(uint elem) {
   uint32_t word = elem >> word_bits;
@@ -75,5 +73,44 @@
       return false;
     }
   }
   return true;
 }
+
+#ifndef PRODUCT
+void VectorSet::print_on(outputStream* st) const {
+  st->print("VectorSet(" PTR_FORMAT ")", p2i(this));
+  if (is_empty()) {
+    st->print_cr(" empty");
+    return;
+  }
+
+  bool first = false;
+  for (uint i = 0; i < (_size << word_bits); ++i) {
+    if (test(i)) {
+      if (!first) {
+        st->print(" [%u", i);
+        first = true;
+      } else {
+        st->print(",%u", i);
+      }
+    }
+  }
+  st->print_cr("]");
+}
+#endif
+
+VectorSet intersect(const VectorSet& lhs, const VectorSet& rhs) {
+  VectorSet result;
+  uint min;
+  if (lhs._size > rhs._size) {
+    result.grow(lhs._size);
+    min = rhs._size;
+  } else {
+    result.grow(rhs._size);
+    min = lhs._size;
+  }
+  for (uint i = 0; i < min; ++i) {
+    result._data[i] = lhs._data[i] & rhs._data[i];
+  }
+  return result;
+}
